requireHelper = require './require_helper'
Lib = requireHelper 'index.js'

chai = require 'chai'
expect = chai.expect

describe 'Instantiate Class', ->

  it 'can instantiate of its constructor function', ->
    test = new Lib()
    expect(test).to.be.an.instanceOf(Lib)
    test = null

  it 'has its isolated state', ->
    person1 = new Lib({ name: 'Carl' });
    person2 = new Lib({ name: 'Max' });

    expect(person1.get('name')).to.equal 'Carl'
    expect(person2.get('name')).to.equal 'Max'

    person1 = null
    person2 = null

  it 'state can have an undefined variable', ->
    person3 = new Lib()
    expect(person3.get('name')).to.equal undefined
    person3 = null

describe 'fetching', ->

  it 'fetches', (done) ->
    google = new Lib({ name: 'Sergey' })
    google.fetch('http://www.google.com').then (response, body) ->
      done()
    .catch (err) ->
      console.error err

  it 'errors', (done) ->
    google = new Lib({ name: 'Sergey' })
    google.fetch('unknown').then (response, body) ->
      console.log response
    .catch (err) ->
      done()