# NPM frontend boilerplate


## Global name

If you implement a plugin for Marionette, you will only need the Marionette plugin name and no `module.exports` will be needed.

If you implement a simple function, you will only need the standalone name.

### Marionette plugin name

Defined in src/view.coffee

```coffee
  Marionette.G4.BoilerPlate
```

### Standalone name

Defined in grunt/browserify.coffee

```coffee
  G4.boilerPlate
```

## NPM scripts

To build & run all tests (unit and functional)
```sh
$ npm run travis
```

To open istanbul report in your default browser
```sh
$ npm run report
```

To open SpecRunner in your default browser
```sh
$ npm run spec
```

To open functional test in your default browser
```sh
$ npm run example
```

To publish your module with safety
```sh
$ npm run update_package
```

## How to install web driver

1. Download last version of the driver from google page [Chromedriver]
2. Unzip it in the folder of your choice
3. Add chromedriver path to environment variable path
   e.g.: '/Users/user/Documents/drivers/'

### Example for MAC
1. Go to your home

  ```sh
  $ cd
  ```

2. Edit .bash_profile

  ```sh
  $ nano .bash_profile
  ```

3. Add those lines

  ```
  export chromeBinaryPath='/Users/user/Documents/drivers/'
  export PATH="$chromeBinaryPath:$PATH"
  ```

4. Restart your terminal and check it

  ```
  $ echo $PATH
  ```


[//]: #

  [Chromedriver]: <https://sites.google.com/a/chromium.org/chromedriver/>